--- src/include/pg_config.h.orig	2010-08-24 22:07:14.000000000 +0200
+++ src/include/pg_config.h	2010-08-24 22:08:16.000000000 +0200
@@ -724,11 +724,17 @@
 /* The size of `off_t', as computed by sizeof. */
 #define SIZEOF_OFF_T 8
 
+#ifdef __LP64__
+  #define SZ  8
+#else
+  #define SZ  4
+#endif
+
 /* The size of `size_t', as computed by sizeof. */
-#define SIZEOF_SIZE_T 8
+#define SIZEOF_SIZE_T SZ
 
 /* The size of `void *', as computed by sizeof. */
-#define SIZEOF_VOID_P 8
+#define SIZEOF_VOID_P SZ
 
 /* Define to 1 if you have the ANSI C header files. */
 #define STDC_HEADERS 1

--- src/include/postgres.h.orig	2009-09-13 09:11:58.000000000 +0200
+++ src/include/postgres.h	2009-09-13 09:12:56.000000000 +0200
@@ -314,15 +314,11 @@
 #define GET_1_BYTE(datum)	(((Datum) (datum)) & 0x000000ff)
 #define GET_2_BYTES(datum)	(((Datum) (datum)) & 0x0000ffff)
 #define GET_4_BYTES(datum)	(((Datum) (datum)) & 0xffffffff)
-#if SIZEOF_DATUM == 8
-#define GET_8_BYTES(datum)	((Datum) (datum))
-#endif
+#define GET_8_BYTES(datum)	((int64_t) (datum))
 #define SET_1_BYTE(value)	(((Datum) (value)) & 0x000000ff)
 #define SET_2_BYTES(value)	(((Datum) (value)) & 0x0000ffff)
 #define SET_4_BYTES(value)	(((Datum) (value)) & 0xffffffff)
-#if SIZEOF_DATUM == 8
-#define SET_8_BYTES(value)	((Datum) (value))
-#endif
+#define SET_8_BYTES(value)	((int64_t) (value))
 
 /*
  * DatumGetBool
